﻿using TravelCompanyContracts.BindingModels;
using TravelCompanyContracts.ViewModels;
using TravelCompanyDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel.DataAnnotations.Schema;
using PrecastConcretePlantDatabaseImplement.Models;

namespace TravelCompanyDatabaseImplement.Models
{
    public class Travel : ITravelModel
    {
        public int Id { get; set; }
        [Required]
        public string TravelName { get; set; } = string.Empty;
        [Required]
        public DateTime DateStart { get; set; } = DateTime.Now;
        [Required]
        public string TravelDescription { get; private set; } = string.Empty;
        [Required]
        public int TouristId { get; private set; }

        public virtual Tourist Tourist { get; set; }
        [ForeignKey("TravelId")]
        public virtual List<ExcursionTravel> ExcursionTravels { get; set; } = new();

        public static Travel? Create(TravelBindingModel model)
        {
            if (model == null)
            {
                return null;
            }
            return new Travel()
            {
                Id = model.Id,
                TravelName = model.TravelName,
                DateStart = model.DateStart,
                TouristId = model.TouristId,
                TravelDescription = model.TravelDescription
            };
        }

        public void Update(TravelBindingModel model)
        {
            if (model == null)
            {
                return;
            }
            TravelName = model.TravelName;
            DateStart = model.DateStart;
            TravelDescription = model.TravelDescription;
        }
        public TravelViewModel GetViewModel => new()
        {
            Id = Id,
            TravelName = TravelName,
            DateStart = DateStart,
            TouristId = TouristId,
            TravelDescription = TravelDescription
        };
    }
}
